{ hostRegistry, config, pkgs, lib, ... }:

{
  imports = [
    ./proxy.nix
    ./stats.nix
  ];

  networking.hostName = "public-access-proxy";
  networking.useNetworkd = true;
  networking.interfaces.eth0 = {
    ipv4.addresses = [{
      address = "172.20.73.45";
      prefixLength = 26;
    }];
  };
  networking.defaultGateway = "172.20.73.1";

  my.services.proxy = {
    enable = true;
    proxyHosts = [
      {
        hostNames = [ "grafana.hq.c3d2.de" ];
        proxyTo.host = "grafana.serv.zentralwerk.org";
      }
      {
        hostNames = [ "ticker.c3d2.de" ];
        proxyTo.host = "ticker.serv.zentralwerk.org";
      }
      {
        hostNames = [ "gitea.c3d2.de" ];
        proxyTo.host = "172.20.73.53";
      }
      {
        hostNames = [ "vps1.nixvita.de" "vps1.codetu.be" "nixvita.de" ];
        proxyTo.host = "172.20.73.51";
      }
      {
        hostNames = [ "stream.hq.c3d2.de" ];
        proxyTo.host = hostRegistry.hosts.stream.ip4;
      }
      {
        hostNames = [ "mobilizon.c3d2.de" ];
        proxyTo.host = hostRegistry.hosts.mobilizon.ip4;
      }
      {
        hostNames = [ "sdr.hq.c3d2.de" ];
        proxyTo.host = hostRegistry.hosts.radiobert.ip4;
      }
    ];
  };

  networking.firewall.allowedTCPPorts = [ 80 443 ];

  system.stateVersion = "18.09";
}
